<?php
/** [BEGIN HEADER] **
 * COPYRIGHT: (c) 2005 Brice Burgess / All Rights Reserved    
 * LICENSE: http://www.gnu.org/copyleft.html GNU/GPL 
 * AUTHOR: Brice Burgess <bhb@iceburg.net>
 * SOURCE: http://pommo.sourceforge.net/
 *
 *  :: RESTRICTIONS ::
 *  1. This header must accompany all portions of code contained within.
 *  2. You must notify the above author of modifications to contents within.
 * 
 ** [END HEADER]**/

/**********************************
	INITIALIZATION METHODS
*********************************/
define('_IS_VALID', TRUE);

require ('../../bootstrap.php');

require_once (bm_baseDir . '/inc/db_templates.php'); // Mailing History Database Handling
require_once (bm_baseDir . '/inc/class.pager.php');

$poMMo = & fireup("secure");
$logger = & $poMMo->_logger;
$dbo = & $poMMo->_dbo;

/**********************************
	SETUP TEMPLATE, PAGE
 *********************************/
$smarty = & bmSmartyInit();
$smarty->assign('returnStr', _T('Mailings Page'));

/* SET PAGE STATE
 * limit		- Nr. of Mailings displayed per Pager-Site
 * mailcount	- Nr. of Mailings in mailing_templates table
 */
 
// default key/value pairs of this page's state
// default maybe the last sent mail on top? and not ASC id
$pmState = array(
	'limit' => '10',
	'sortOrder' => 'ASC',
	'sortBy' => 'name'
);
$poMMo->stateInit('mailings_templates',$pmState);

$limit = $poMMo->stateVar('limit',$_REQUEST['limit']);
$sortOrder = $poMMo->stateVar('sortOrder',$_REQUEST['sortOrder']);
$sortBy = $poMMo->stateVar('sortBy',$_REQUEST['sortBy']);

$smarty->assign('state',$poMMo->_state);


$templatescount = dbGetTemplatesCount($dbo); // func in inc/db_templates.php

/* Instantiate Pager class (Using modified template from author) */
$p = new Pager();
if ($p->findStart($limit) > $templatescount) $_GET['page'] = '1';
$pages = $p->findPages($templatescount, $limit);
$start = $p->findStart($limit); 
$pagelist = $p->pageList($_GET['page'], $pages);


// Fetch Mailings
$templates = & dbGetLimitedTemplates($dbo, $start, $limit, $sortBy, $sortOrder); // func in inc/db_templates.php

// If there are mailings display them
$smarty->assign('templates', $templates);
$smarty->assign('pagelist', $pagelist);
$smarty->assign('rowsinset', $templatescount);

$smarty->display('admin/mailings/mailings_templates.tpl');

bmKill();
?>